/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the PathTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PathTrait{}

// PathTrait struct for PathTrait
type PathTrait struct {
	Path NullableString `json:"path,omitempty"`
}

// NewPathTrait instantiates a new PathTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPathTrait() *PathTrait {
	this := PathTrait{}
	return &this
}

// NewPathTraitWithDefaults instantiates a new PathTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPathTraitWithDefaults() *PathTrait {
	this := PathTrait{}
	return &this
}

// GetPath returns the Path field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PathTrait) GetPath() string {
	if o == nil || IsNil(o.Path.Get()) {
		var ret string
		return ret
	}
	return *o.Path.Get()
}

// GetPathOk returns a tuple with the Path field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PathTrait) GetPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Path.Get(), o.Path.IsSet()
}

// HasPath returns a boolean if a field has been set.
func (o *PathTrait) HasPath() bool {
	if o != nil && o.Path.IsSet() {
		return true
	}

	return false
}

// SetPath gets a reference to the given NullableString and assigns it to the Path field.
func (o *PathTrait) SetPath(v string) {
	o.Path.Set(&v)
}

// SetPathNil sets the value for Path to be an explicit nil
func (o *PathTrait) SetPathNil() {
	o.Path.Set(nil)
}

// UnsetPath ensures that no value is present for Path, not even an explicit nil
func (o *PathTrait) UnsetPath() {
	o.Path.Unset()
}

func (o PathTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PathTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Path.IsSet() {
		toSerialize["path"] = o.Path.Get()
	}
	return toSerialize, nil
}

type NullablePathTrait struct {
	value *PathTrait
	isSet bool
}

func (v NullablePathTrait) Get() *PathTrait {
	return v.value
}

func (v *NullablePathTrait) Set(val *PathTrait) {
	v.value = val
	v.isSet = true
}

func (v NullablePathTrait) IsSet() bool {
	return v.isSet
}

func (v *NullablePathTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePathTrait(val *PathTrait) *NullablePathTrait {
	return &NullablePathTrait{value: val, isSet: true}
}

func (v NullablePathTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePathTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
